import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport, syntaxTree } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const spec_Builtin = {__proto__:null,argv:64, argc:64, true:64, false:64, mod:72, rem:72, div:72, trunc_div:72};
const parser = LRParser.deserialize({
  version: 14,
  states: "(vOYQPOOOOQO'#Cb'#CbOOQO'#Ce'#CeOOQO'#DO'#DOOwQPO'#DOOYQPO'#CdOOQO'#C{'#C{O!uQPO'#CzOYQPO'#CnOOQO'#Cz'#CzO#sQPO'#CpO$XQPO'#DXO$mQPO'#CyOOQO'#Cq'#CqOYQPO'#CxOOQO'#Cx'#CxQOQPOOO%eQPO,59OOoQPO,59OO%lQQO,59QOOQO'#Co'#CoO%zQPO,59YOYQPO,59YOOQO'#Cr'#CrO&SQPO,59[O#sQPO,59[O&ZQPO,59eOOQO-E6o-E6oOOQO,59d,59dO'RQPO1G.jOOQO1G.j1G.jO#sQPO1G.jO'YQQO'#CgO'_QPO'#CkOOQO'#DT'#DTOOQO1G.l1G.lOOQO,59`,59`OOQO1G.t1G.tO'dQPO1G.tOOQO-E6r-E6rOOQO-E6p-E6pOOQO1G.v1G.vO'lQPO1G.vP'qQPO'#CyPOQO'#Cy'#CyOOQO7+$U7+$UO'|QPO7+$UO(RQQO,59RO(ZQQO,59VOOQO7+$`7+$`P%}QPO'#CtOOQO7+$b7+$bPOQO,59e,59eOOQO<<Gp<<GpOOQO1G.m1G.mO(iQQO'#CsOOQO'#Cs'#CsO(}QQO1G.qOOQO-E6q-E6qOOQO7+$]7+$]",
  stateData: ")c~OkOSPOS~ORUOSUOTSOVROaWOpPOqTOsQOtQO~ORrXSrXTrXarXioXprXqrXsoXtoXvoXzoXurX`oXyoX~OvcOinXsnXtnXznX`nXynXRnXSnXTnXanXpnXqnXunX~ORUOSUOTUOaWOpPOqTO~OsQOtQOzjOi{X`{Xy{X~ORmXSmXTmXVmXamXi{XpmXqmXsmXtmX`{Xy{X~OunO~P#sORpO[pO^rOqqO~O`uOytO~OzyO~P#sORmaSmaTmaVmaamai{apmaqmasmatma`{ay{a~Ou}O~P#sOx!PO~O^!QO~O`!ROytO~Oz!TO~OsQOtQOz!UO~Ou!VO~OR!WO]!WO~OR!XO[pO^rOqqO~Ox!PORgX[gX^gXqgXugX~OR!XO[pO^rOqqOu!]O~ORs~",
  goto: "%c|PPPPPP}P}![!j!wPPP!wPP!j!|#S#Y#b#l#rPPP#x$P$V$lPP$yPPPP%SPPP%ZgUOTWY^afhimoYROTW^fSiZ{RobgXOTWY^afhimoVrc!Q!ZQeWRvfX[OW^fU^OWfRk^QhYQmaTxhmQ!Z!QR![!ZQfWRwfQ`OTdWfX]OW^fWZOW^fQbTWgYahmQziR!OogVOTWY^afhimoWYOW^fRaTQscT!Y!Q!ZU_OWfRl^",
  nodeNames: "⚠ LineComment Program Integer String Variable Nullary Builtin Sexpr Opalias Annotation Range -oo oo Type_name Type_sexpr } { Variants Variant Stmt",
  maxTerm: 43,
  nodeProps: [
    ["openedBy", 16,"{"],
    ["closedBy", 17,"}"]
  ],
  skippedNodes: [0,1],
  repeatNodeCount: 4,
  tokenData: ",n~RxX^#opq#oqr$drs$ost$jtu&]uv&kvw$jxy'Syz'Xz{$j{|$j}!O'^!O!P)k!P!Q)x!Q!R)}!R![(r![!]*Y!]!^*_!^!_*d!_!`*r!`!a*{!c!}+W#Q#R$j#R#S+`#T#c+`#c#d+n#d#o+`#o#p,d#p#q$j#q#r,i#r#s$j#y#z#o$f$g#o#BY#BZ#o$IS$I_#o$I|$JO#o$JT$JU#o$KV$KW#o&FU&FV#o~#tYk~X^#opq#o#y#z#o$f$g#o#BY#BZ#o$IS$I_#o$I|$JO#o$JT$JU#o$KV$KW#o&FU&FV#oP$gP!_!`$jP$oOsP~$rVOr$ors%Xs#O$o#O#P%^#P;'S$o;'S;=`&V<%lO$o~%^OS~~%aRO;'S$o;'S;=`%j;=`O$o~%mWOr$ors%Xs#O$o#O#P%^#P;'S$o;'S;=`&V;=`<%l$o<%lO$o~&YP;=`<%l$o~&bRT~!c!}&]#R#S&]#T#o&]~&pSP~OY&kZ;'S&k;'S;=`&|<%lO&k~'PP;=`<%l&k~'XOq~~'^Ou~~'cRsP!Q!R'l!R![(r#c#d)`~'oQ#U#V'u#l#m(W~'xP!R!S'{~(QQR~!Q!R'{!R!S'{~(ZR!R![(d!c!i(d#T#Z(d~(iRR~!Q![(d!c!i(d#T#Z(d~(wRR~!Q![(r!g!h)Q#X#Y)Q~)TP!R![)W~)]PR~!Q![)WQ)cP#c#d)fQ)kO[QR)nP!O!P)qR)xOxQsP~)}Oy~~*SQR~#U#V'u#l#m(W~*_Ov~~*dOz~P*iRsP}!O$j!^!_$j!_!`$jP*uQ!_!`$j!`!a$jP+QQsP!_!`$j!`!a$j~+]P^~#T#o+WP+eRVP!Q![+`#R#S+`#T#o+`R+sTVP!Q![+`#R#S+`#T#c+`#c#d,S#d#o+`R,ZR]QVP!Q![+`#R#S+`#T#o+`~,iOa~~,nO`~",
  tokenizers: [0, 1],
  topRules: {"Program":[0,2]},
  specialized: [{term: 7, get: (value) => spec_Builtin[value] || -1}],
  tokenPrec: 384
});

// https://github.com/jared-hughes/polygolf/blob/main/src/IR/opcodes.ts
const opcodes = [
    "add",
    "sub",
    "mul",
    "div",
    "pow",
    "mod",
    "bit_and",
    "bit_or",
    "bit_xor",
    "min",
    "max",
    "lt",
    "leq",
    "eq",
    "neq",
    "gt",
    "geq",
    "or",
    "and",
    "array_contains",
    "list_contains",
    "table_contains_key",
    "set_contains",
    "array_get",
    "list_get",
    "table_get",
    "list_push",
    "concat",
    "repeat",
    "text_contains",
    "text_byte_find",
    "text_codepoint_find",
    "text_split",
    "text_get_byte",
    "text_get_byte_slice",
    "text_get_codepoint",
    "text_get_codepoint_slice",
    "join",
    "right_align",
    "int_to_bin_aligned",
    "int_to_hex_aligned",
    "simplify_fraction",
    "abs",
    "bit_not",
    "neg",
    "not",
    "int_to_text",
    "int_to_bin",
    "int_to_hex",
    "text_to_int",
    "bool_to_int",
    "int_to_text_byte",
    "int_to_codepoint",
    "list_length",
    "text_byte_length",
    "text_codepoint_length",
    "text_split_whitespace",
    "join",
    "text_byte_reversed",
    "text_codepoint_reversed",
    "text_byte_to_int",
    "codepoint_to_int",
    "true",
    "false",
    "print",
    "println",
    "print_int",
    "println_int",
    "text_replace",
    "array_set",
    "list_set",
    "table_set",
    "sorted",
];
const special_exprs = [
    "func",
    "array",
    "list",
    "set",
    "table",
    "conditional",
    "unsafe_conditional",
    "while",
    "for",
    "for_argv",
    "if",
    "any_int",
];
const words = (x) => x.split(" ");
words("<- + - * ^ & | ~ >> << == != <= < >= > => # .. mod rem div trunc_div");
const nullaryTypes = words("Void Bool Int 0..oo Text Ascii");
const sexprTypes = words("Text Ascii List Array Table Set Func");
function getVariableNames(context, currentFrom) {
    const tree = syntaxTree(context.state);
    const result = [];
    tree.iterate({
        enter(node) {
            if (node.name === "Variable" && currentFrom !== node.from)
                result.push(context.state.sliceDoc(node.from, node.to));
        },
    });
    return result;
}
function isTypeNode(node) {
    return (node !== null && (node.name === "Type_sexpr" || isTypeNode(node.parent)));
}
function isTypeContext(context) {
    return isTypeNode(syntaxTree(context.state).resolveInner(context.pos, -1));
}
function autocomplete(context) {
    var _a;
    const typeOptions = nullaryTypes
        .map((label) => ({ label, type: "type", boost: 1 }))
        .concat(sexprTypes.map((label) => ({
        label: "(" + label,
        type: "type",
        boost: 0,
    })));
    const keywordOptions = opcodes
        .concat(special_exprs)
        .map((label) => ({ label, type: "keyword" }));
    const varMatch = context.matchBefore(/\$\w*/);
    if (varMatch) {
        return {
            from: varMatch.from,
            options: getVariableNames(context, varMatch.from).map((label) => ({
                label,
                type: "variable",
            })),
        };
    }
    const annotationMatch = context.matchBefore(/: ?\(?\w*/);
    if (annotationMatch) {
        return {
            from: context.matchBefore(/\(?\w*/).from,
            options: typeOptions,
        };
    }
    let word = context.matchBefore(/\w*/);
    if (word !== null &&
        word.from == word.to &&
        ((_a = context.matchBefore(/\(/)) === null || _a === void 0 ? void 0 : _a.text) !== "(" &&
        !isTypeContext(context) &&
        !context.explicit)
        return null;
    return {
        from: word.from,
        options: isTypeContext(context) ? typeOptions : keywordOptions,
    };
}
const PolygolfLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Variants: delimitedIndent({ closing: "}", align: false }),
            }),
            foldNodeProp.add({
                Variants: foldInside,
            }),
            styleTags({
                Variable: tags.variableName,
                String: tags.string,
                Builtin: tags.keyword,
                Nullary: tags.constant(tags.keyword),
                Opalias: tags.operator,
                Type_name: tags.typeName,
                Integer: tags.integer,
                LineComment: tags.lineComment,
                "( )": tags.paren,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: "%" },
        autocomplete,
    },
});
function polygolf() {
    return new LanguageSupport(PolygolfLanguage);
}

export { PolygolfLanguage, polygolf };
